#!/bin/bash


mkDomain(){
echo "(define (domain raos_keys)"
echo " (:types light key)"
echo " (:predicates"
echo "  (crouching)"
echo "  (not_crouching)"
echo "  (not_wearing_sunglasses)"
echo "  (wearing_sunglasses)"
echo "  (key_at ?k - key ?l - light)"
echo "  (have_key ?k)"
echo "  (neq ?l1 ?l2 - light)"
echo "  (at ?l - light)"
echo "  (opens ?k - key ?l - light)"
echo "  (open ?l - light)"
echo " )" 

line=""
for((i = 0; i <= $KEYS; i++)); do {
 line="$line k$i"
}; done
echo " (:constants $line - key)"

echo " (:action exchange_sunglasses"
echo "  :precondition (and)"
echo "  :effect (and (when (wearing_sunglasses)"
echo "                     (and (not (wearing_sunglasses))"
echo "			  (not_wearing_sunglasses)))"
echo "	       (when (not_wearing_sunglasses)"
echo "                     (and (wearing_sunglasses)"
echo "			  (not (not_wearing_sunglasses))))"
echo " ))"


echo " (:action stand_up"
echo "  :effect (and (not_crouching) (not (crouching))))"

echo " (:action crouch"
echo "  :effect (and (crouching) (not (not_crouching))))"

echo " (:action search_under_light"
echo "  :parameters (?l - light)"
echo "  :precondition (and (at ?l) (wearing_sunglasses) (crouching))"
echo "  :effect (and"
for((i=1; i <= $KEYS; i++)); do {
echo "		(when (and (open ?l) (key_at k$i ?l)) (have_key k$i))"
}; done
echo "          )"
echo " )"

echo " (:action goto_light"
echo "  :parameters (?l1 ?l2 - light)"
echo "  :precondition (and (neq ?l1 ?l2)" 
echo "                     (at ?l1)" 
echo "                     (not_wearing_sunglasses)"
echo "                     (not_crouching))"
echo "  :effect (and (at ?l2) (not (at ?l1)))"
echo " )"



echo " (:action open_gate"
echo "  :parameters (?l - light ?k - key)"
echo "  :precondition (and "
echo "                  (at ?l)                " 
echo "                  (not_wearing_sunglasses)"
echo "                  (not_crouching)"
echo "                )"
echo "  :effect (and (when (and (have_key ?k) (opens ?k ?l)) (open ?l))))"

echo ")"
}

mkProblem(){
echo "(define (problem raos_keys1)"
echo " (:domain raos_keys)"

for((i=1; i <= $KEYS; i++)); do {
 line="$line l$i"
};done
echo " (:objects $line - light)"
echo " (:init  (and"
echo "   (at l1)"
echo "   (have_key k0)"
echo "   (not_wearing_sunglasses)"
echo "   (not_crouching)"
line=""
for((i=1; i <= $KEYS; i++)); do {
 line="$line (opens k0 l$i)"
};done
echo "   (oneof $line)"

for((i=1; i <= $KEYS; i++)); do {
 line=""
 for((j=1; j <= $KEYS; j++)); do {
  line="$line (key_at k$i l$j)"
 };done
 echo "   (oneof $line)"
 line=""
 for((j=1; j <= $KEYS; j++)); do {
  line="$line (opens k$i l$j)"
 };done
 echo "   (oneof $line)"

 for((k=1; k<=$KEYS; k++)); do {
  line="(not (key_at k$i l$k))"
  for((j=1; j <= $KEYS; j++)); do {
   if [ $j != $k ]; then
    line="$line (opens k$i l$j)"
   fi
  };done
  echo "   (or $line)"
  echo "   (or (not (key_at k$i l$k)) (not (opens k$i l$k)))"
 }; done
};done


for((i=1; i <= $KEYS; i++)); do {
 line=""
 for((j=1; j <= $KEYS; j++)); do {
  line="$line (opens k$j l$i)"
 };done
 echo "   (oneof $line)"   

 line=""
 for((j=1; j <= $KEYS; j++)); do {
  line="$line (key_at k$j l$i)"
 };done
 echo "   (oneof $line)"   

};done

for((i=1; i <= $KEYS; i++)); do {
 for((j=1; j <= $KEYS; j++)); do {
  if [ $i != $j ]; then
   echo "   (neq l$i l$j)"
  fi
 };done
};done 

echo "  )"
echo " )"
echo " (:goal (and "
for((j=1; j <= $KEYS; j++)); do {
 echo "          (have_key k$j)"
};done
echo "        ))"
echo ")"

}


KEYS=$1
mkProblem $KEYS > p$KEYS.pddl
mkDomain $KEYS > d$KEYS.pddl