(define (domain forest)
  (:types
     ;;;;;;;top level grid;;;;;;;;
     location 
     problem

     ;;;;;;;subproblem;;;;;;;
     sub-location 
     log-location
     package
     truck
     plane
     city
     block
  )
  (:constants
	 x1 x2 
         y1 y2 - location

     ;;;;;;;sub-problem types;;;;;
     grid logistics blocksworld - problem

     ;;;;;;;blocksworld subproblem;;;
     a b c - block

     ;;;;;;;logistics subproblem;;;
     t1 t2 - truck
     a1 - plane
     p1 - package
     l11 l12 l21 l22 - log-location
     c1 c2 - city
  )
  (:predicates 
    ;;grid coordinates
   (at-x ?loc - location)
   (at-y ?loc - location)
   (succ-loc ?loc1 ?loc2 - location)

    ;;subproblem at grid point is solved
   (solved ?loc - location)

    ;;the subproblem at grid point can be solved
   ;(enabled ?locx ?locy - location) 
    ;;used to link subproblems 
   ;(enables ?loc1x ?loc1y ?loc2x ?loc2y  - location) 

   ;;initialize the subproblem at grid point
   ;(initialized ?locx ?locy - location)
   ;(ninitialized ?locx ?locy - location)

   ;;subproblem type at each grid point
   (problem-at ?loc - location ?p - problem)

   ;;;;;grid navigation subproblem;;;;;;;;;;;;;
   (s-at-x ?loc - sub-location ?lx ?ly - location)
   (s-at-y ?loc - sub-location ?lx ?ly - location)
   (s-succ-loc ?loc1 ?loc2 - sub-location)
   (s-init-x ?loc - sub-location ?lx ?ly - location)
   (s-init-y ?loc - sub-location ?lx ?ly - location)
   (s-goal-x ?loc - sub-location ?lx ?ly - location)
   (s-goal-y ?loc - sub-location ?lx ?ly - location)


   ;;;;;logistics subproblem;;;;;;;;;;;;;;;;;;;
   (s-pkg-at ?p - package ?loc - log-location ?lx ?ly - location)
   (s-truck-at ?t - truck ?loc - log-location ?lx ?ly - location)
   (s-plane-at ?t - plane ?loc - log-location ?lx ?ly - location)
   (s-city-loc ?loc - log-location ?c - city)
   (s-airport-loc ?loc - log-location)
   (s-pkg-in-t ?p - package ?t - truck ?lx ?ly - location)
   (s-pkg-in-a ?p - package ?a - plane ?lx ?ly - location)

   ;;;;;blocksworld subproblem;;;;;;;;;;;;;;;;;
   (s-on ?b1 ?b2 - block ?lx ?ly - location)
   (s-on-table ?b - block ?lx ?ly - location)
   (s-clear ?b - block ?lx ?ly - location)
   (s-empty ?lx ?ly - location)
   (s-holding ?b - block ?lx ?ly - location)

  )

  ;;;;;top-level grid navigation actions;;;;;;;

  (:action up-x
   :effect (and
	(when (and (at-x x1) (at-y y1) (solved x1 y1)) 
              (and (not (at-x x1)) (at-x x2)))
	(when (and (at-x x1) (at-y y2) (solved x1 y2)) 
              (and (not (at-x x1)) (at-x x2)))
  ))

  (:action up-y
   :effect (and
	(when (and (at-x x1) (at-y y1) (solved x1 y1)) 
              (and (not (at-y y1)) (at-y y2)))
	(when (and (at-x x2) (at-y y1) (solved x2 y1)) 
              (and (not (at-y y1)) (at-y y2)))
 ))

  (:action down-x
   :effect (and
	(when (and (at-x x2) (at-y y1) (solved x2 y1)) 
              (and (not (at-x x2)) (at-x x1)))
	(when (and (at-x x2) (at-y y2) (solved x2 y2)) 
              (and (not (at-x x2)) (at-x x1)))
  ))

  (:action down-y
   :effect (and
	(when (and (at-x x1) (at-y y2) (solved x1 y2)) 
              (and (not (at-y y2)) (at-y y1)))
	(when (and (at-x x2) (at-y y2) (solved x2 y2)) 
              (and (not (at-y y2)) (at-y y1)))
 ))


  ;;;;;grid navigation sub-problem;;;;;;;;;;;


  (:action s-up-x
   :parameters (?sloc1x ?sloc1y ?sloc2x - sub-location
                ?locx ?locy - location)
   :precondition (and) 
   :effect (when (and (problem-at ?locx ?locy grid) (at-x ?locx) (at-y ?locy)
			(s-succ-loc ?sloc1x ?sloc2x)	
		      (s-at-x ?sloc1x ?locx ?locy) (s-at-y ?sloc1y ?locx ?locy))
		(and (s-at-x ?sloc2x ?locx ?locy) (not (s-at-x ?sloc1x ?locx ?locy))))
  )

  (:action s-up-y
   :parameters (?sloc1x ?sloc1y ?sloc2y - sub-location
                ?locx ?locy - location)
   :precondition (and) 
   :effect (when (and (problem-at ?locx ?locy grid) (at-x ?locx) (at-y ?locy)
			(s-succ-loc ?sloc1y ?sloc2y)
		      (s-at-x ?sloc1x ?locx ?locy) (s-at-y ?sloc1y ?locx ?locy))
		(and (s-at-y ?sloc2y ?locx ?locy) (not (s-at-y ?sloc1y ?locx ?locy))))
  )

  (:action s-down-x
   :parameters (?sloc1x ?sloc1y ?sloc2x - sub-location
                ?locx ?locy - location)
   :precondition (and)
   :effect (when (and (problem-at ?locx ?locy grid) (at-x ?locx) (at-y ?locy)
			 (s-succ-loc ?sloc2x ?sloc1x)
		      (s-at-x ?sloc1x ?locx ?locy) (s-at-y ?sloc1y ?locx ?locy))
		(and (s-at-x ?sloc2x ?locx ?locy) (not (s-at-x ?sloc1x ?locx ?locy))))
  )

  (:action s-down-y
   :parameters (?sloc1x ?sloc1y ?sloc2y - sub-location
                ?locx ?locy - location)
   :precondition (and)
   :effect (when (and (problem-at ?locx ?locy grid) (at-x ?locx) (at-y ?locy)
			(s-succ-loc ?sloc2y ?sloc1y)
		      (s-at-x ?sloc1x ?locx ?locy) (s-at-y ?sloc1y ?locx ?locy))
		(and (s-at-y ?sloc2y ?locx ?locy) (not (s-at-y ?sloc1y ?locx ?locy))))
  )

  (:action solve-grid
   :parameters (?slocx ?slocy - sub-location
	        ?locx ?locy - location)
   :precondition (and)
   :effect (when (and (problem-at ?locx ?locy grid) (at-x ?locx) (at-y ?locy)                 
		      (s-at-x ?slocx ?locx ?locy) (s-at-y ?slocy ?locx ?locy)
                      (s-goal-x ?slocx ?locx ?locy) (s-goal-y ?slocy ?locx ?locy)
                 )
		(solved ?locx ?locy) 
           )
  )


  ;;;;;logistics sub-problem;;;;;;;;;;;


  (:action load-truck
   :parameters (?t - truck ?p - package ?loc - log-location ?locx ?locy - location)
   :precondition (and)
   :effect (when (and (problem-at ?locx ?locy logistics) (at-x ?locx) (at-y ?locy)
		 	(s-truck-at ?t ?loc ?locx ?locy) (s-pkg-at ?p ?loc ?locx ?locy))
                 (and (s-pkg-in-t ?p ?t ?locx ?locy) (not (s-pkg-at ?p ?loc ?locx ?locy))))
  )

  (:action load-plane
   :parameters (?a - plane ?p - package ?loc - log-location ?locx ?locy - location)
   :precondition (and)
   :effect (when (and (problem-at ?locx ?locy logistics) (at-x ?locx) (at-y ?locy)
		 	(s-plane-at ?a ?loc ?locx ?locy) (s-pkg-at ?p ?loc ?locx ?locy))
		(and (s-pkg-in-a ?p ?a ?locx ?locy) (not (s-pkg-at ?p ?loc ?locx ?locy))))
  )

  (:action unload-truck
   :parameters (?t - truck ?p - package ?loc - log-location ?locx ?locy - location)
   :precondition (and)
   :effect (when (and (problem-at ?locx ?locy logistics) (at-x ?locx) (at-y ?locy)
			 (s-truck-at ?t ?loc ?locx ?locy) (s-pkg-in-t ?p ?t ?locx ?locy))
		(and (s-pkg-at ?p ?loc ?locx ?locy) (not (s-pkg-in-t ?p ?t ?locx ?locy))))
  )

  (:action unload-plane
   :parameters (?a - plane ?p - package ?loc - log-location ?locx ?locy - location)
   :precondition (and)
   :effect (when (and (problem-at ?locx ?locy logistics) (at-x ?locx) (at-y ?locy)
			 (s-plane-at ?a ?loc ?locx ?locy) (s-pkg-in-a ?p ?a ?locx ?locy))
		(and (s-pkg-at ?p ?loc ?locx ?locy) (not (s-pkg-in-a ?p ?a ?locx ?locy))))
  )

  (:action move-truck
   :parameters (?t - truck ?loc1 ?loc2 - log-location ?c - city ?locx ?locy - location)
   :precondition (and)
   :effect (when (and (problem-at ?locx ?locy logistics) (at-x ?locx) (at-y ?locy)
			 (s-truck-at ?t ?loc1 ?locx ?locy) 
			(s-city-loc ?loc1 ?c)
                      (s-city-loc ?loc2 ?c)
		      (not (= ?loc1 ?loc2))
                 )
		(and (not (s-truck-at ?t ?loc1 ?locx ?locy)) (s-truck-at ?t ?loc2 ?locx ?locy)))
  ) 

  (:action move-plane
   :parameters (?a - plane ?loc1 ?loc2 - log-location ?locx ?locy - location)
   :precondition (and)
   :effect (when (and (problem-at ?locx ?locy logistics) (at-x ?locx) (at-y ?locy)
			 (s-plane-at ?a ?loc1 ?locx ?locy)                       
			 (s-airport-loc ?loc1)
                      (s-airport-loc ?loc2)
		      (not (= ?loc1 ?loc2))
                 )
		(and (not (s-plane-at ?a ?loc1 ?locx ?locy)) (s-plane-at ?a ?loc2 ?locx ?locy)))
  ) 

  (:action solve-logistics
   :parameters (?locx ?locy - location)
   :effect (when (and (problem-at ?locx ?locy logistics) (at-x ?locx) (at-y ?locy)
                      (s-pkg-at p1 l22 ?locx ?locy)
			;(s-pkg-in-t p1 t1 ?locx ?locy)
                 )
	        (solved ?locx ?locy) 
           )
  )


  ;;;;;blocksworld sub-problem;;;;;;;;;;;
  (:action stack
   :parameters (?b1 ?b2 - block ?locx ?locy - location)
   :precondition (and)
   :effect (when (and (problem-at ?locx ?locy blocksworld) (at-x ?locx) (at-y ?locy)
		       (s-holding ?b1 ?locx ?locy) (s-clear ?b2 ?locx ?locy))
	 	(and (s-on ?b1 ?b2 ?locx ?locy) (not (s-holding ?b1 ?locx ?locy)) 
                     (not (s-clear ?b2 ?locx ?locy)) (s-clear ?b1 ?locx ?locy) (s-empty ?locx ?locy)))
  )

  (:action putdown
   :parameters (?b1 - block ?locx ?locy - location)
   :precondition (and)
   :effect (when (and (problem-at ?locx ?locy blocksworld) (at-x ?locx) (at-y ?locy)
                      (s-holding ?b1 ?locx ?locy))
		(and (s-on-table ?b1 ?locx ?locy) (not (s-holding ?b1 ?locx ?locy)) 
                     (s-clear ?b1 ?locx ?locy) (s-empty ?locx ?locy)))
  )

  (:action unstack
   :parameters (?b1 ?b2 - block ?locx ?locy - location)
   :precondition (and)
   :effect (when (and (problem-at ?locx ?locy blocksworld) (at-x ?locx) (at-y ?locy)
                      (s-empty ?locx ?locy) (s-clear ?b1 ?locx ?locy) (s-on ?b1 ?b2 ?locx ?locy))
		(and (not (s-on ?b1 ?b2 ?locx ?locy)) (s-holding ?b1 ?locx ?locy) (s-clear ?b2 ?locx ?locy)
                     (not (s-clear ?b1 ?locx ?locy)) (not (s-empty ?locx ?locy))))
  )

  (:action pickup
   :parameters (?b1 - block ?locx ?locy - location)
   :precondition (and)
   :effect (when (and (problem-at ?locx ?locy blocksworld) (at-x ?locx) (at-y ?locy)
                      (s-empty ?locx ?locy) (s-clear ?b1 ?locx ?locy)
                 )
		(and (not (s-on-table ?b1 ?locx ?locy)) (s-holding ?b1 ?locx ?locy) 
                     (not (s-clear ?b1 ?locx ?locy)) (not (s-empty ?locx ?locy))))
  )

  (:action solve-blocksworld
   :parameters (?locx ?locy - location)
   :effect (when (and (problem-at ?locx ?locy blocksworld) (at-x ?locx) (at-y ?locy)
                      (s-on a b ?locx ?locy) (s-on b c ?locx ?locy)
                 )
		(solved ?locx ?locy) 
           )
  )

)


(define (problem p1)
 (:domain forest)
 (:objects sx1 sx2 
           sy1 sy2 - sub-location

 )
 (:init 
	;;;;;;;;top level grid;;;;;;;
	(oneof (at-x x1) (at-x x2))
	(oneof (at-y y1) (at-y y2))
	
;	(at-x x1)
;	(at-y y1)

	(succ-loc x1 x2)
	(succ-loc y1 y2)


	;;;;;;;;subproblems;;;;;;;;;;
;       (oneof ;(problem-at x1 y1 grid) 
              (problem-at x1 y1 logistics) 
;              (problem-at x1 y1 blocksworld)
;       )
       (oneof (problem-at x1 y2 grid) 
              ;(problem-at x1 y2 logistics) 
              (problem-at x1 y2 blocksworld)
       )
       (oneof (problem-at x2 y1 grid) 
              (problem-at x2 y1 logistics) 
              ;(problem-at x2 y1 blocksworld)
       )
      (oneof
	 ;(problem-at x2 y2 grid) 
         (problem-at x2 y2 logistics) 
        (problem-at x2 y2 blocksworld)
      )


	;;;;;;;;grid sub-problem;;;;;;
             
;	(s-at-x sx2 x1 y1) 
;	(s-at-y sy2 x1 y1)
;	(s-goal-x sx1 x1 y1) 
;	(s-goal-y sy1 x1 y1)

	(s-at-x sx2 x1 y2) 
	(s-at-y sy2 x1 y2)
	(s-goal-x sx1 x1 y2) 
	(s-goal-y sy1 x1 y2)

	(s-at-x sx2 x2 y1) 
	(s-at-y sy2 x2 y1)
	(s-goal-x sx1 x2 y1) 
	(s-goal-y sy1 x2 y1)

;	(s-at-x sx2 x2 y2) 
;	(s-at-y sy2 x2 y2)
;	(s-goal-x sx1 x2 y2) 
;	(s-goal-y sy1 x2 y2)
	
	;;;all grid problems
	(s-succ-loc sx1 sx2)
	(s-succ-loc sy1 sy2)

	;;;;;;logistics sub-problem;;
                (s-city-loc l11 c1) (s-city-loc l12 c1)
                (s-city-loc l21 c2) (s-city-loc l22 c2)
		(s-airport-loc l11) (s-airport-loc l21)


		(s-pkg-at p1 l12 x1 y1) (s-truck-at t1 l12 x1 y1)
                (s-truck-at t2 l21 x1 y1) (s-plane-at a1 l11 x1 y1)

;		(s-pkg-at p1 l12 x1 y2) (s-truck-at t1 l12 x1 y2)
;                (s-truck-at t2 l21 x1 y2) (s-plane-at a1 l11 x1 y2)

		(s-pkg-at p1 l12 x2 y1) (s-truck-at t1 l12 x2 y1)
                (s-truck-at t2 l21 x2 y1) (s-plane-at a1 l11 x2 y1)

		(s-pkg-at p1 l21 x2 y2) (s-truck-at t1 l12 x2 y2)
                (s-truck-at t2 l21 x2 y2) (s-plane-at a1 l11 x2 y2)
	
	;;;;;;blocks sub-problem;;;;;;
;	(s-on c a x1 y1) (s-on-table a x1 y1) (s-on-table b x1 y1) 
;        (s-clear b x1 y1) (s-clear c x1 y1) (s-empty x1 y1)

	(s-on c a x1 y2) (s-on-table a x1 y2) (s-on-table b x1 y2) 
        (s-clear b x1 y2) (s-clear c x1 y2) (s-empty x1 y2)

;	(s-on c a x2 y1) (s-on-table a x2 y1) (s-on-table b x2 y1) 
;        (s-clear b x2 y1) (s-clear c x2 y1) (s-empty x2 y1)

	(s-on c a x2 y2) (s-on-table a x2 y2) (s-on-table b x2 y2) 
        (s-clear b x2 y2) (s-clear c x2 y2) (s-empty x2 y2)


 )
 (:goal 
	(and (at-x x2) (at-y y2) ;(solved x2 y2)

        )
 )
)