#!/bin/bash


mkDomain(){
SIZE=$1

echo "(define (domain forest)"
echo "  (:types"
echo "     ;;;;;;;top level grid;;;;;;;;"
echo "     location" 
echo "     prob"
echo ""
echo "     ;;;;;;;subproblem;;;;;;;"
echo "     sub_location "
echo "     log_location"
echo "     package"
echo "     truck"
echo "     plane"
echo "     city"
echo "     block"
echo "  )"
echo "  (:constants"

for((i=1; i<="$SIZE"; i++)); do {
 line="$line x$i y$i"
}; done
echo "    $line - location"
echo ""
echo "     ;;;;;;;sub-problem types;;;;;"
echo "     grid logistics blocksworld - prob"
echo ""
echo "     ;;;;;;;blocksworld subproblem;;;"
echo "     a b c - block"
echo ""
echo "     ;;;;;;;logistics subproblem;;;"
echo "     t1 t2 - truck"
echo "     a1 - plane"
echo "     p1 - package"
echo "     l11 l12 l21 l22 - log_location"
echo "     c1 c2 - city"
echo "  )"
echo "  (:predicates "
echo "    ;;grid coordinates"
echo "   (at ?loc - location)"
echo "   (succ_loc ?loc1 ?loc2 - location)"
echo ""
echo "    ;;subproblem at grid point is solved"
echo "   (solved ?loc - location)"
echo ""
echo "   ;;subproblem type at each grid point"
echo "   (prob_at ?loc - location ?p - prob)"
echo ""
#echo "   ;;the subproblem at grid point can be solved"
#echo "   (enabled ?loc - location) "
#echo "    ;;used to link subproblems"
#echo "   (enables ?loc ?loc1 - location)"
echo ""
echo "   ;;;;;grid navigation subproblem;;;;;;;;;;;;;"
echo "   (s_at_x ?loc - sub_location ?l - location)"
echo "   (s_at_y ?loc - sub_location ?l - location)"
echo "   (s_succ_loc ?loc1 ?loc2 - sub_location)"
echo "   (s_goal_x ?loc - sub_location ?l - location)"
echo "   (s_goal_y ?loc - sub_location ?l - location)"
echo ""
echo "   ;;;;;logistics subproblem;;;;;;;;;;;;;;;;;;;"
echo "   (s_pkg_at ?p - package ?loc - log_location ?l - location)"
echo "   (s_truck_at ?t - truck ?loc - log_location ?l - location)"
echo "   (s_plane_at ?t - plane ?loc - log_location ?l - location)"
echo "   (s_city_loc ?loc - log_location ?c - city)"
echo "   (s_airport_loc ?loc - log_location)"
echo "   (s_pkg_in_t ?p - package ?t - truck ?l - location)"
echo "   (s_pkg_in_a ?p - package ?a - plane ?l - location)"
echo "   (neq ?l1 ?l - location)"
echo ""
echo "   ;;;;;blocksworld subproblem;;;;;;;;;;;;;;;;;"
echo "   (s_on ?b1 ?b2 - block ?l - location)"
echo "   (s_on_table ?b - block ?l - location)"
echo "   (s_clear ?b - block ?l - location)"
echo "   (s_empty ?l - location)"
echo "   (s_holding ?b - block ?l - location)"
echo "  )"
echo ""
echo "  ;;;;;top-level grid navigation actions;;;;;;;"

echo "  (:action up_x"
echo "   :effect (and"
for((i=1; i<$SIZE; i++)); do {
NXT=`expr $i + 1`
echo "	(when (and (at x$i) (solved x$i)) "
echo "        (and (not (at x$i)) (at x$NXT)))"
}; done
echo "  ))"
echo ""
echo "  (:action up_y"
echo "   :effect (and"
for((i=1; i<$SIZE; i++)); do {
NXT=`expr $i + 1`
echo "	(when (and (at y$i) (solved y$i)) "
echo "        (and (not (at y$i)) (at y$NXT)))"
}; done
echo " ))"

echo "  (:action down_x"
echo "   :effect (and"
for((i=$SIZE; i>1; i--)); do {
PRV=`expr $i - 1`
echo "	(when (and (at x$i) (solved x$i)) "
echo "        (and (not (at x$i)) (at x$PRV)))"
}; done
echo "  ))"
echo ""
echo "  (:action down-y" 
echo "  :effect (and"
for((i=$SIZE; i>1; i--)); do {
PRV=`expr $i - 1`
echo "	(when (and (at y$i) (solved y$i)) "
echo "        (and (not (at y$i)) (at y$PRV)))"
}; done
echo " ))"
echo ""
#echo " (:action enable_subprob"
#echo "  :parameters (?loc ?loc1 - location)"
#echo "  :precondition (and)"
#echo "  :effect (when (and (solved ?loc) (enables ?loc ?loc1)) (enabled ?loc1))"
#echo " )"
echo ""
echo "  ;;;;;grid navigation sub-problem;;;;;;;;;;;"
echo ""
echo "  (:action s_up_x"
echo "   :parameters (?sloc1x ?sloc1y ?sloc2x - sub_location"
echo "                ?loc - location)"
#echo "   :precondition (and)"
echo "   :effect (when (and  (prob_at ?loc grid) (at ?loc) "
echo "			(s_succ_loc ?sloc1x ?sloc2x)	"
echo "		      (s_at_x ?sloc1x ?loc) (s_at_y ?sloc1y ?loc))"
echo "		(and (s_at_x ?sloc2x ?loc) (not (s_at_x ?sloc1x ?loc))))"
echo "  )"
echo ""
echo "  (:action s_up_y"
echo "   :parameters (?sloc1x ?sloc1y ?sloc2y - sub_location"
echo "                ?loc - location)"
#echo "   :precondition (and) "
echo "   :effect (when (and  (prob_at ?loc grid) (at ?loc)"
echo "			(s_succ_loc ?sloc1y ?sloc2y)"
echo "		      (s_at_x ?sloc1x ?loc) (s_at_y ?sloc1y ?loc))"
echo "		(and (s_at_y ?sloc2y ?loc) (not (s_at_y ?sloc1y ?loc))))"
echo "  )"
echo ""
echo "  (:action s_down_x"
echo "   :parameters (?sloc1x ?sloc1y ?sloc2x - sub_location" 
echo "               ?loc - location)"
#echo "   :precondition (and)"
echo "   :effect (when (and  (prob_at ?loc grid) (at ?loc)"
echo "			 (s_succ_loc ?sloc2x ?sloc1x)"
echo "		      (s_at_x ?sloc1x ?loc) (s_at_y ?sloc1y ?loc))"
echo "		(and (s_at_x ?sloc2x ?loc) (not (s_at_x ?sloc1x ?loc))))"
echo "  )"
echo ""
echo "  (:action s_down_y"
echo "   :parameters (?sloc1x ?sloc1y ?sloc2y - sub_location"
echo "                ?loc - location)"
#echo "   :precondition (and)"
echo "   :effect (when (and  (prob_at ?loc grid) (at ?loc)"
echo "			(s_succ_loc ?sloc2y ?sloc1y)"
echo "		      (s_at_x ?sloc1x ?loc) (s_at_y ?sloc1y ?loc))"
echo "		(and (s_at_y ?sloc2y ?loc) (not (s_at_y ?sloc1y ?loc))))"
echo "  )"
echo ""
echo "  (:action solve_grid"
echo "   :parameters (?slocx ?slocy - sub_location"
echo "	        ?loc - location)"
#echo "   :precondition (and)"
echo "   :effect (when (and  (prob_at ?loc grid) (at ?loc)"
echo "		      (s_at_x ?slocx ?loc) (s_at_y ?slocy ?loc)"
echo "                     (s_goal_x ?slocx ?loc) (s_goal_y ?slocy ?loc)"
echo "                 )"	
echo "		(solved ?loc) "
echo "           )"
echo "  )"
echo ""
echo "  ;;;;;logistics sub-problem;;;;;;;;;;;"
echo ""
echo "  (:action load_truck"
echo "   :parameters (?t - truck ?p - package ?loc - log_location ?l - location)"
#echo "   :precondition (and)"
echo "   :effect (when (and  (prob_at ?l logistics) (at ?l)"
echo "    	 	      (s_truck_at ?t ?loc ?l) (s_pkg_at ?p ?loc ?l))"
echo "                 (and (s_pkg_in_t ?p ?t ?l) (not (s_pkg_at ?p ?loc ?l))))"
echo "  )"
echo ""
echo "  (:action load_plane"
echo "   :parameters (?a - plane ?p - package ?loc - log_location ?l - location)" 
#echo "   :precondition (and)"
echo "   :effect (when (and  (prob_at ?l logistics) (at ?l)"
echo "		      (s_plane_at ?a ?loc ?l) (s_pkg_at ?p ?loc ?l))"
echo "		(and (s_pkg_in_a ?p ?a ?l) (not (s_pkg_at ?p ?loc ?l))))"
echo "  )"
echo ""
echo "  (:action unload_truck"
echo "   :parameters (?t - truck ?p - package ?loc - log_location ?l - location)"
#echo "   :precondition (and)"
echo "   :effect (when (and  (prob_at ?l logistics) (at ?l)"
echo "		      (s_truck_at ?t ?loc ?l) (s_pkg_in_t ?p ?t ?l))"
echo "		(and (s_pkg_at ?p ?loc ?l) (not (s_pkg_in_t ?p ?t ?l))))"
echo "  )"
echo ""
echo "  (:action unload_plane"
echo "   :parameters (?a - plane ?p - package ?loc - log_location ?l - location)"
#echo "   :precondition (and)"
echo "   :effect (when (and  (prob_at ?l logistics) (at ?l)"
echo "		      (s_plane_at ?a ?loc ?l) (s_pkg_in_a ?p ?a ?l))"
echo "		(and (s_pkg_at ?p ?loc ?l) (not (s_pkg_in_a ?p ?a ?l))))"
echo "  )"
echo ""
echo "  (:action move_truck"
echo "   :parameters (?t - truck ?loc1 ?loc2 - log_location ?c - city ?l - location)"
#echo "   :precondition (and)"
echo "   :effect (when (and  (prob_at ?l logistics) (at ?l)"
echo "		      (s_truck_at ?t ?loc1 ?l) (s_city_loc ?loc1 ?c)"
echo "                      (s_city_loc ?loc2 ?c) (neq ?loc1 ?loc2)"
echo "                 )"
echo "		(and (not (s_truck_at ?t ?loc1 ?l)) (s_truck_at ?t ?loc2 ?l)))"
echo "  ) "
echo ""
echo "  (:action move_plane"
echo "   :parameters (?a - plane ?loc1 ?loc2 - log_location ?l - location)"
#echo "   :precondition (and)"
echo "   :effect (when (and  (prob_at ?l logistics) (at ?l)"
echo "		      (s_plane_at ?a ?loc1 ?l) (s_airport_loc ?loc1)"
echo "                      (s_airport_loc ?loc2) (neq ?loc1 ?loc2)"
echo "                 )"
echo "		(and (not (s_plane_at ?a ?loc1 ?l)) (s_plane_at ?a ?loc2 ?l)))"
echo "  ) "
echo ""
echo "  (:action solve_logistics"
echo "   :parameters (?l - location)"
#echo "   :precondition (and)"
echo "   :effect (when (and  (prob_at ?l logistics) (at ?l)"
echo "                      (s_pkg_at p1 l22 ?l)"
echo "                 )"
echo "	        (solved ?l) "
echo "           )"
echo "  )"
echo "" 
echo "  ;;;;;blocksworld sub-problem;;;;;;;;;;;"
echo "  (:action stack"
echo "   :parameters (?b1 ?b2 - block ?loc - location)"
#echo "   :precondition (and)"
echo "   :effect (when (and  (prob_at ?loc blocksworld) (at ?loc)"
echo "		       (s_holding ?b1 ?loc) (s_clear ?b2 ?loc))"
echo "	 	(and (s_on ?b1 ?b2 ?loc) (not (s_holding ?b1 ?loc)) "
echo "                     (not (s_clear ?b2 ?loc)) (s_clear ?b1 ?loc) (s_empty ?loc)))"
echo "  )"
echo ""
echo "  (:action putdown"
echo "   :parameters (?b1 - block ?loc - location)"
#echo "   :precondition (and)"
echo "   :effect (when (and  (prob_at ?loc blocksworld) (at ?loc)"
echo "                      (s_holding ?b1 ?loc))"
echo "		(and (s_on_table ?b1 ?loc) (not (s_holding ?b1 ?loc)) "
echo "                     (s_clear ?b1 ?loc) (s_empty ?loc)))"
echo  " )"
echo ""
echo "  (:action unstack"
echo "   :parameters (?b1 ?b2 - block ?loc - location)"
#echo "   :precondition (and)"
echo "   :effect (when (and  (prob_at ?loc blocksworld) (at ?loc)"
echo "                      (s_empty ?loc) (s_clear ?b1 ?loc) (s_on ?b1 ?b2 ?loc))"
echo "		(and (not (s_on ?b1 ?b2 ?loc)) (s_holding ?b1 ?loc) (s_clear ?b2 ?loc)"
echo "                     (not (s_clear ?b1 ?loc)) (not (s_empty ?loc))))"
echo "  )"

echo "  (:action pickup"
echo "   :parameters (?b1 - block ?loc - location)"
#echo "   :precondition (and)"
echo "   :effect (when (and  (prob_at ?loc blocksworld) (at ?loc)"
echo "                      (s_empty ?loc) (s_clear ?b1 ?loc)"
echo "                 )"
echo "		(and (not (s_on_table ?b1 ?loc)) (s_holding ?b1 ?loc) "
echo "                     (not (s_clear ?b1 ?loc)) (not (s_empty ?loc))))"
echo "  )"
echo ""
echo "  (:action solve_blocksworld"
echo "   :parameters (?loc - location)"
#echo "   :precondition (and)"
echo "   :effect (when (and  (prob_at ?loc blocksworld) (at ?loc)"
echo "                      (s_on a b ?loc) (s_on b c ?loc)"
echo "                 )"
echo "		(solved ?loc) "
echo "           )"
echo "  )"
echo ""
echo ")"

}

mkProblem(){
SIZE=$1
echo "(define (problem p$SIZE)"
echo " (:domain forest)"
echo " (:objects sx1 sx2 "
echo "           sy1 sy2 - sub_location"
echo " )"
echo " (:init (and"
echo "	;;;;;;;;top level grid;;;;;;;"
line=""
for((i=1;i<="$SIZE";i++)); do {
line="$line (at x$i)"
}; done
echo "  (oneof $line)"
line=""
for((i=1;i<="$SIZE";i++)); do {
line="$line (at y$i)"
}; done
echo "  (oneof $line)"

for((i=1;i<"$SIZE";i++)); do {
NXT=`expr $i + 1`
echo "  (succ_loc x$i x$NXT)"
}; done

for((i=1;i<"$SIZE";i++)); do {
NXT=`expr $i + 1`
echo "  (succ_loc y$i y$NXT)"
}; done




echo "	;;;;;;;;subproblems;;;;;;;;;;"
for((i=1; i<="$SIZE"; i++)); do {
X=`expr $RANDOM % 3`
PROBLEM=`expr 1 + $X`
if [ $PROBLEM == 1 ] ; then
 echo "  (prob_at x$i grid)"
 echo "	 (s_at_x sx2 x$i)"
 echo "	 (s_at_y sy2 x$i)"
 echo "	 (s_goal_x sx1 x$i)"
 echo "  (s_goal_y sy1 x$i)"
elif [ $PROBLEM == 2 ]; then
 echo "  (prob_at x$i logistics)"
 echo "  (s_pkg_at p1 l12 x$i) (s_truck_at t1 l12 x$i)"
 echo "  (s_truck_at t2 l21 x$i) (s_plane_at a1 l11 x$i)"
else
 echo "  (prob_at x$i blocksworld)"
 echo "	 (s_on c a x$i) (s_on_table a x$i) (s_on_table b x$i)" 
 echo "  (s_clear b x$i) (s_clear c x$i) (s_empty x$i)"
fi
}; done

for((i=1; i<="$SIZE"; i++)); do {
X=`expr $RANDOM % 3`
PROBLEM=`expr 1 + $X`
if [ $PROBLEM == 1 ]; then
 echo "  (prob_at y$i grid)"
 echo "	 (s_at_x sx2 y$i)"
 echo "	 (s_at_y sy2 y$i)"
 echo "	 (s_goal_x sx1 y$i)"
 echo "	 (s_goal_y sy1 y$i)"
elif [ $PROBLEM == 2 ]; then
 echo "  (prob_at y$i logistics)"
 echo "  (s_pkg_at p1 l12 y$i) (s_truck_at t1 l12 y$i)"
 echo "  (s_truck_at t2 l21 y$i) (s_plane_at a1 l11 y$i)"
else
 echo "  (prob_at y$i blocksworld)"
 echo "  (s_on c a y$i) (s_on_table a y$i) (s_on_table b y$i)" 
 echo "  (s_clear b y$i) (s_clear c y$i) (s_empty y$i)"
fi
}; done

echo "	;;;all grid problems"
echo "  (s_succ_loc sx1 sx2)"
echo "  (s_succ_loc sy1 sy2)"
echo ""
echo "  ;;;;;;logistics sub-problem;;"
echo "  (s_city_loc l11 c1) (s_city_loc l12 c1)"
echo "  (s_city_loc l21 c2) (s_city_loc l22 c2)" 
echo "  (s_airport_loc l11) (s_airport_loc l21)"
echo "  (neq l11 l12) (neq l11 l21) (neq l11 l22)"
echo "  (neq l12 l11) (neq l12 l21) (neq l12 l22)"
echo "  (neq l21 l12) (neq l21 l11) (neq l21 l22)"
echo "  (neq l22 l12) (neq l22 l21) (neq l22 l11)"
echo ""
echo " ))"
echo " (:goal "
echo "	(and (at x1) (at y1))"
echo " )"
echo ")"

}


SIZE=$1

mkDomain $SIZE > d0$SIZE.pddl
mkProblem $SIZE > p0$SIZE.pddl