(define (domain raos_keys)
 (:types light key)
 (:predicates
  (crouching)
  (not_crouching)
  (not_wearing_sunglasses)
  (wearing_sunglasses)
  (key_at ?k - key ?l - light)
  (have_key ?k)
  (neq ?l1 ?l2 - light)
  (at ?l - light)
  (opens ?k - key ?l - light)
  (open ?l - light)
 ) 
 (:constants k0 k1 k2 k3 - key)
 (:action exchange_sunglasses
  :precondition (and)
  :effect (and (when (wearing_sunglasses) 
                     (and (not (wearing_sunglasses))
			  (not_wearing_sunglasses))) 
	       (when (not_wearing_sunglasses) 
                     (and (wearing_sunglasses)
			  (not (not_wearing_sunglasses))))
 ))


 (:action stand_up
  :effect (and (not_crouching) (not (crouching))))

 (:action crouch
  :effect (and (crouching) (not (not_crouching))))

 (:action search_under_light
  :parameters (?l - light)
  :precondition (and (at ?l) (wearing_sunglasses) (crouching) )
  :effect (and
		(when (and (open ?l) (key_at k1 ?l)) (have_key k1))
		(when (and (open ?l) (key_at k2 ?l)) (have_key k2))
		(when (and (open ?l) (key_at k3 ?l)) (have_key k3))
          )
 )

 (:action goto_light
  :parameters (?l1 ?l2 - light)
  :precondition (and (neq ?l1 ?l2) 
                     (at ?l1) 
                     (not_wearing_sunglasses)
                     (not_crouching))
  :effect (and (at ?l2) (not (at ?l1)))
 )



 (:action open_gate
  :parameters (?l - light ?k - key)
  :precondition (and 
                  (at ?l)                 
                  (not_wearing_sunglasses)
                  (not_crouching)
                )
  :effect (and (when (and (have_key ?k) (opens ?k ?l)) (open ?l))))

)


(define (problem raos_keys1)
 (:domain raos_keys)
 (:objects 

   l1 l2 l3 - light
 )
 (:init  (and
   (at l1)
   (have_key k0)
   (not_wearing_sunglasses)
   (not_crouching)

   (oneof (opens k0 l1) (opens k0 l2) (opens k0 l3))

   (oneof (key_at k1 l1) (key_at k1 l2) (key_at k1 l3))
   (oneof (opens k1 l1) (opens k1 l2) (opens k1 l3))
   (or (not (key_at k1 l1)) (opens k1 l2) (opens k1 l3))
   (or (not (key_at k1 l2)) (opens k1 l1) (opens k1 l3))
   (or (not (key_at k1 l3)) (opens k1 l1) (opens k1 l2))
   (or (not (key_at k1 l1)) (not (opens k1 l1)))
   (or (not (key_at k1 l2)) (not (opens k1 l2)))
   (or (not (key_at k1 l3)) (not (opens k1 l3)))

   (oneof (key_at k2 l1) (key_at k2 l2) (key_at k2 l3))
   (oneof (opens k2 l1) (opens k2 l2) (opens k2 l3))
   (or (not (key_at k2 l1)) (opens k2 l2) (opens k2 l3))
   (or (not (key_at k2 l2)) (opens k2 l1) (opens k2 l3))
   (or (not (key_at k2 l3)) (opens k2 l1) (opens k2 l2))
   (or (not (key_at k2 l1)) (not (opens k2 l1)))
   (or (not (key_at k2 l2)) (not (opens k2 l2)))
   (or (not (key_at k2 l3)) (not (opens k2 l3)))


   (oneof (key_at k3 l1) (key_at k3 l2) (key_at k3 l3))
   (oneof (opens k3 l1) (opens k3 l2) (opens k3 l3))
   (or (not (key_at k3 l1)) (opens k3 l2) (opens k3 l3))
   (or (not (key_at k3 l2)) (opens k3 l1) (opens k3 l3))
   (or (not (key_at k3 l3)) (opens k3 l1) (opens k3 l2))
   (or (not (key_at k3 l1)) (not (opens k3 l1)))
   (or (not (key_at k3 l2)) (not (opens k3 l2)))
   (or (not (key_at k3 l3)) (not (opens k3 l3)))
   
   (oneof (opens k1 l1) (opens k2 l1) (opens k3 l1))	
   (oneof (opens k1 l2) (opens k2 l2) (opens k3 l2))	
   (oneof (opens k1 l3) (opens k2 l3) (opens k3 l3))	

   (oneof (key_at k1 l1) (key_at k2 l1) (key_at k3 l1))	
   (oneof (key_at k1 l2) (key_at k2 l2) (key_at k3 l2))	
   (oneof (key_at k1 l3) (key_at k2 l3) (key_at k3 l3))	

 

   (neq l1 l2)
   (neq l1 l3)
   (neq l2 l1)
   (neq l2 l3)
   (neq l3 l1)
   (neq l3 l2)
  )
 )
 (:goal (and 
          (have_key k1)
          (have_key k2)
          (have_key k3)

        ))
)